#pragma once

#include "ActorInterface.h"
#include "WASCommand.h"
#include "WASActor.h"

class CWASAddGroup : public CWASCommand
{
public:
	CWASAddGroup(CWASActor *pActor);
	~CWASAddGroup(void);

	void ExecuteAsync(void);

	void SetParameter(LPCWSTR strGroupName, GTBuddyAddGroupType addGroupType, int nSortOrder)
	{
		m_strGroupName = strGroupName;
		m_sResult.nID = -1;
		m_addGroupType = addGroupType;
		m_nSortOrder = nSortOrder;
	}

private:
	bool ParseAndEventFire(nfc::CIkXMLDom * pDom);

protected:
	// override in drived class
	virtual void OnWasResponse(trid_t /*trid*/, bool /*bSuccess*/, int /*nWinINetErrorCode*/, int /*nHttpResponseCode*/, 
		LPCSTR /*szWasResCodeInHeader*/, 
		LPCSTR /*szWasResCodeInXml*/,
		nfc::CIkXMLDom * /*pDom*/);

	virtual void OnRequestTimeout(CHttpFacade * /*pHttpF*/, DWORD /*dwSeconds*/);

private:

	WSTRING m_strGroupName;
	int  m_nSortOrder;
	P_GT_BUDDY_GROUP_DATA m_sResult;
	GTBuddyAddGroupType m_addGroupType;
};
